(function () {
  'use strict';

  angular
    .module('app.calculadora')
    .controller('CalculadoraController', CalculadoraController);

  CalculadoraController.$inject = [
    '$scope',
    '$state',
    '$ionicPopup',
    '$translate',
    'UserDataHelper'
  ];

  /* @ngInject */
  function CalculadoraController(
    $scope,
    $state,
    $ionicPopup,
    $translate,
    UserDataHelper) {

    var _this = this;

    // Public
    _this.userData = null;

    // Methods
    _this.calcular = calcular;
    _this.detalhesConta = detalhesConta;

    // Constructor
    init();

    /**
     * Inicializa as funcionalidades do controller.
     */
    function init() {
      cordova.plugins.firebase.analytics.logEvent("userEvent", {view: "Dados da conta de energia"});
      _this.userData = angular.copy(UserDataHelper.get());
    }

    function calcular(form) {

      _this.userDataForm.conta.$setValidity('valid', true);
      _this.userDataForm.energia.$setValidity('valid', true);

      if (!_this.userData.conta) {
        _this.userDataForm.conta.$setValidity('valid', false);
      }

      if (!_this.userData.energia) {
        _this.userDataForm.energia.$setValidity('valid', false);
      }

      if (_this.userDataForm.$valid) {
        UserDataHelper.set(_this.userData);
        $state.go('resultado');
      }
    }

    function detalhesConta() {
      cordova.plugins.firebase.analytics.logEvent("userEvent", {action: 'view_popup_detalhes_conta'});
      $translate(['ATTENTION'])
        .then(function (translations) {
          alertPopup = $ionicPopup.alert({
            title: translations.ATTENTION,
            template: `
              <style>
                .popup-container .popup { 
                  width:90% !important; 
                }
                .popup-container .popup-body {
                  background-color: #0667a8;
                  padding: 0;
                }
                .image {
                  width: 100%;
                  display: block;
                  height: 500px;
                  background-image: url(img/detalhes_conta.png);
                  background-repeat: no-repeat;
                  background-size: contain;
                  background-position: center;
                }
              </style>
              <div class="image" />
            `
          });
        });
    }
  }
})();
