(function() {
  'use strict';

  angular
    .module('app.core')
    .config(ionicConfigs)
    .config(['$provide', provideConfigs])
    .config(translateConfigs);

  ionicConfigs.$inject = ['$ionicConfigProvider'];

  function ionicConfigs($ionicConfigProvider) {
    $ionicConfigProvider.views.maxCache(15);
    $ionicConfigProvider.views.swipeBackEnabled(false);
    $ionicConfigProvider.scrolling.jsScrolling(true);
    $ionicConfigProvider.backButton.text('').previousTitleText(false);
    $ionicConfigProvider.navBar.alignTitle('center');
  }

  provideConfigs.$inject = ['$provide'];

  function provideConfigs($provide) {
    $provide.decorator('$locale', ['$delegate', function($delegate) {
      $delegate.NUMBER_FORMATS.PATTERNS[1].negPre = '\u00A4-';
      $delegate.NUMBER_FORMATS.PATTERNS[1].negSuf = '';
      return $delegate;
    }]);
  }

  translateConfigs.$inject = ['$translateProvider'];

  function translateConfigs($translateProvider) {

    var language = navigator.language.split('-')[0];

    $translateProvider
      .useStaticFilesLoader({
        prefix: 'js/locales/',
        suffix: '.json'
      })
      .registerAvailableLanguageKeys(['en', 'es', 'pt'], {
        'en': 'en',
        'en_GB': 'en',
        'en_US': 'en',
        'es': 'es',
        'es_ES': 'es',
        'pt': 'pt',
        'pt_BR': 'pt'
      })
      .preferredLanguage(language)
      .fallbackLanguage('en')
      .useSanitizeValueStrategy('escapeParameters');
  }

})();
