(function() {
  'use strict';

  angular
    .module('app.core')
    .config(routing);

  routing.$inject = [
    '$stateProvider',
    '$urlRouterProvider'
  ];

  function routing(
    $stateProvider,
    $urlRouterProvider) {

    // Redirects and Otherwise

    /**
     * Use $urlRouterProvider to configure any redirects (when) and invalid urls (otherwise).
     * If the url is ever invalid, e.g. '/asdf', then redirect to '/' aka the home state
     */
    $urlRouterProvider.otherwise('/');

    // State Configurations

    $stateProvider
      .state('home', {
        url: '/',
        templateUrl: 'home.html',
        controller: 'HomeController',
        controllerAs: 'homeCtrl'
      })
      .state('calculadora', {
        url: '/calculadora',
        templateUrl: 'calculadora.html',
        controller: 'CalculadoraController',
        controllerAs: 'calculadoraCtrl'
      })
      .state('resultado', {
        url: '/resultado',
        templateUrl: 'resultado.html',
        controller: 'ResultadoController',
        controllerAs: 'resultadoCtrl'
      })
      .state('detalhes', {
        url: '/detalhes',
        templateUrl: 'detalhes.html',
        controller: 'DetalhesController',
        controllerAs: 'detalhesCtrl'
      })
      .state('configurations', {
        url: '/configurations',
        templateUrl: 'configurations.html',
        controller: 'ConfigurationsController',
        controllerAs: 'configurationsCtrl'
      })
      .state('languages', {
        url: '/languages',
        templateUrl: 'languages.html',
        controller: 'LanguagesController',
        controllerAs: 'languagesCtrl'
      });
  }
})();
