(function() {
  'use strict';

  angular
    .module('app.languages')
    .factory('LanguagesDomainService', LanguagesDomainService);

  LanguagesDomainService.$inject = [];

  function LanguagesDomainService() {

    var ENGLISH = {
      key: 'en',
      value: 'ENGLISH'
    };

    var SPANISH = {
      key: 'es',
      value: 'SPANISH'
    };

    var PORTUGUESE = {
      key: 'pt',
      value: 'PORTUGUESE'
    };

    return {
      getLanguages: getLanguages,
      getDefaultLanguage: getDefaultLanguage,
      isSupported: isSupported
    };

    function getLanguages() {
      return [ENGLISH, SPANISH, PORTUGUESE];
    }

    function getDefaultLanguage() {
      return ENGLISH;
    }

    function isSupported(lang) {
      var languages = getLanguages();
      for (var i = 0; i < languages.length; i++) {
        var language = languages[i];
        if (language.key === lang) {
          return true;
        }
      }
      return false;
    }
  }
})();
