(function() {
  'use strict';

  angular
    .module('app.languages')
    .controller('LanguagesController', LanguagesController);

  LanguagesController.$inject = [
    '$scope',
    '$state',
    '$ionicPopup',
    '$ionicHistory',
    'UserDataHelper',
    'LanguagesDomainService'
  ];

  /* @ngInject */
  function LanguagesController(
    $scope,
    $state,
    $ionicPopup,
    $ionicHistory,
    UserDataHelper,
    LanguagesDomainService) {

    var _this = this;

    // Public
    _this.languages = [];
    _this.language = null;

    // Methods
    _this.changeLanguage = changeLanguage;

    // Constructor
    init();

    /**
     * Inicializa as funcionalidades do controller.
     */
    function init() {
      cordova.plugins.firebase.analytics.logEvent("userEvent", {view: "Idiomas"});
      _this.languages = LanguagesDomainService.getLanguages();
      var userLocale = UserDataHelper.getLocale();
      for (var i = 0; i < _this.languages.length; i++) {
        var language = _this.languages[i];
        if (userLocale == language.key) {
          _this.language = language.key;
        }
      }
    }

    function changeLanguage(language) {
      cordova.plugins.firebase.analytics.logEvent("userEvent", {action: 'mudou_idioma', idioma: language.key});
      UserDataHelper.changeLocale(language.key);
      $ionicHistory.clearCache();
    }
  }
})();
