(function () {
  "use strict";

  angular.module("app.helper").service("DatabaseHelper", DatabaseHelper);

  DatabaseHelper.$inject = ["$cordovaSQLite"];

  /* @ngInject */
  function DatabaseHelper($cordovaSQLite) {
    var _this = this;
    var dhPath = "solar.db";
    var iosDatabaseLocation = "default"; // https://github.com/xpbrew/cordova-sqlite-storage

    _this.get = function (callback) {
      var location = 0; // https://github.com/an-rahulpandey/cordova-plugin-dbcopy
      window.plugins.sqlDB.copy(
        dhPath,
        location,
        function (response) {
          console.log('[LOGGER]', "db get success", JSON.stringify(response));
          resolveDatabase(callback);
        },
        function (error) {
          console.log('[LOGGER]', "db get error", JSON.stringify(error));
          resolveDatabase(callback);
        }
      );
    };

    _this.delete = function (callback) {
      removeDatabase(callback);
    };

    function removeDatabase(callback) {
      console.log("removing database");
      if (window.sqlitePlugin) {
        console.log("sqlitePlugin found");
        window.sqlitePlugin.deleteDatabase(
          {
            name: dhPath,
            iosDatabaseLocation
          },
          function (response) {
            console.log("db remove success", response);
            callback();
          },
          function (error) {
            console.log("db remove error", error);
            callback();
          }
        );
      } else {
        console.log("No sqlitePlugin");
      }
    }

    function resolveDatabase(callback) {
      window.sqlitePlugin.openDatabase(
        {
          name: dhPath,
          iosDatabaseLocation
        },
        function (db) {
          console.log("db resolve success", db);
          callback(db);
        },
        function (error) {
          console.log("db resolve error", error);
        }
      );
    }
  }
})();
