(function() {
  'use strict';

  angular
    .module('app.helper')
    .filter('roundup', RoundupValue)
    .filter('percentVisual', PercentVisual);

  RoundupValue.$inject = ['MathHelper'];

  function RoundupValue(MathHelper) {

    return filterFunc;

    function filterFunc(rnum, rlength) {
      return MathHelper.round(rnum, rlength);
    }
  }

  PercentVisual.$inject = ['MathHelper'];

  function PercentVisual(MathHelper) {

    return filterFunc;

    function filterFunc(value, round, rlength, appendPercent) {
      var val = round ? MathHelper.round(value, 2) : value;
      var fixedLength = rlength ? rlength : 0;
      var addPercent = appendPercent ? '%' : '';
      return (val * 100).toFixed(fixedLength) + addPercent;
    }
  }

})();
